diff --git a/srvdata/db_phonelottery.go b/srvdata/db_phonelottery.go
index 862250d..cec9d0a 100644
--- a/srvdata/db_phonelottery.go
+++ b/srvdata/db_phonelottery.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_PhoneLotteryMgr = &DB_PhoneLotteryMgr{pool: make(map[int32]*server.DB_PhoneLottery), Datas: &server.DB_PhoneLotteryArray{}}
+var PBDB_PhoneLotteryMgr = &DB_PhoneLotteryMgr{
+    Datas: &server.DB_PhoneLotteryArray{},
+    pool: make(map[int32]*server.DB_PhoneLottery),
+    
+}
 
 type DB_PhoneLotteryMgr struct {
 	Datas *server.DB_PhoneLotteryArray
 	pool  map[int32]*server.DB_PhoneLottery
+	
 }
 
 func (this *DB_PhoneLotteryMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_PhoneLotteryMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_PhoneLotteryMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_PhoneLotteryMgr) GetData(id int32) *server.DB_PhoneLottery {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_PhoneLottery.dat", &ProtobufDataLoader{dh: PBDB_PhoneLotteryMgr})
 }
diff --git a/srvdata/db_playerexp.go b/srvdata/db_playerexp.go
index c362309..6c969f1 100644
--- a/srvdata/db_playerexp.go
+++ b/srvdata/db_playerexp.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_PlayerExpMgr = &DB_PlayerExpMgr{pool: make(map[int32]*server.DB_PlayerExp), Datas: &server.DB_PlayerExpArray{}}
+var PBDB_PlayerExpMgr = &DB_PlayerExpMgr{
+    Datas: &server.DB_PlayerExpArray{},
+    pool: make(map[int32]*server.DB_PlayerExp),
+    
+}
 
 type DB_PlayerExpMgr struct {
 	Datas *server.DB_PlayerExpArray
 	pool  map[int32]*server.DB_PlayerExp
+	
 }
 
 func (this *DB_PlayerExpMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_PlayerExpMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_PlayerExpMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_PlayerExpMgr) GetData(id int32) *server.DB_PlayerExp {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_PlayerExp.dat", &ProtobufDataLoader{dh: PBDB_PlayerExpMgr})
 }
diff --git a/srvdata/db_playerinfo.go b/srvdata/db_playerinfo.go
index 0b037cc..9a6e51d 100644
--- a/srvdata/db_playerinfo.go
+++ b/srvdata/db_playerinfo.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_PlayerInfoMgr = &DB_PlayerInfoMgr{pool: make(map[int32]*server.DB_PlayerInfo), Datas: &server.DB_PlayerInfoArray{}}
+var PBDB_PlayerInfoMgr = &DB_PlayerInfoMgr{
+    Datas: &server.DB_PlayerInfoArray{},
+    pool: make(map[int32]*server.DB_PlayerInfo),
+    
+}
 
 type DB_PlayerInfoMgr struct {
 	Datas *server.DB_PlayerInfoArray
 	pool  map[int32]*server.DB_PlayerInfo
+	
 }
 
 func (this *DB_PlayerInfoMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_PlayerInfoMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_PlayerInfoMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_PlayerInfoMgr) GetData(id int32) *server.DB_PlayerInfo {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_PlayerInfo.dat", &ProtobufDataLoader{dh: PBDB_PlayerInfoMgr})
 }
diff --git a/srvdata/db_playertype.go b/srvdata/db_playertype.go
index 7f0610b..8444d02 100644
--- a/srvdata/db_playertype.go
+++ b/srvdata/db_playertype.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_PlayerTypeMgr = &DB_PlayerTypeMgr{pool: make(map[int32]*server.DB_PlayerType), Datas: &server.DB_PlayerTypeArray{}}
+var PBDB_PlayerTypeMgr = &DB_PlayerTypeMgr{
+    Datas: &server.DB_PlayerTypeArray{},
+    pool: make(map[int32]*server.DB_PlayerType),
+    
+}
 
 type DB_PlayerTypeMgr struct {
 	Datas *server.DB_PlayerTypeArray
 	pool  map[int32]*server.DB_PlayerType
+	
 }
 
 func (this *DB_PlayerTypeMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_PlayerTypeMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_PlayerTypeMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_PlayerTypeMgr) GetData(id int32) *server.DB_PlayerType {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_PlayerType.dat", &ProtobufDataLoader{dh: PBDB_PlayerTypeMgr})
 }
diff --git a/srvdata/db_potodd.go b/srvdata/db_potodd.go
index 68f7abf..869092f 100644
--- a/srvdata/db_potodd.go
+++ b/srvdata/db_potodd.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_PotOddMgr = &DB_PotOddMgr{pool: make(map[int32]*server.DB_PotOdd), Datas: &server.DB_PotOddArray{}}
+var PBDB_PotOddMgr = &DB_PotOddMgr{
+    Datas: &server.DB_PotOddArray{},
+    pool: make(map[int32]*server.DB_PotOdd),
+    
+}
 
 type DB_PotOddMgr struct {
 	Datas *server.DB_PotOddArray
 	pool  map[int32]*server.DB_PotOdd
+	
 }
 
 func (this *DB_PotOddMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_PotOddMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_PotOddMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_PotOddMgr) GetData(id int32) *server.DB_PotOdd {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_PotOdd.dat", &ProtobufDataLoader{dh: PBDB_PotOddMgr})
 }
diff --git a/srvdata/db_propexchange.go b/srvdata/db_propexchange.go
index 9d7ae2c..12a45fe 100644
--- a/srvdata/db_propexchange.go
+++ b/srvdata/db_propexchange.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_PropExchangeMgr = &DB_PropExchangeMgr{pool: make(map[int32]*server.DB_PropExchange), Datas: &server.DB_PropExchangeArray{}}
+var PBDB_PropExchangeMgr = &DB_PropExchangeMgr{
+    Datas: &server.DB_PropExchangeArray{},
+    pool: make(map[int32]*server.DB_PropExchange),
+    
+}
 
 type DB_PropExchangeMgr struct {
 	Datas *server.DB_PropExchangeArray
 	pool  map[int32]*server.DB_PropExchange
+	
 }
 
 func (this *DB_PropExchangeMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_PropExchangeMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_PropExchangeMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_PropExchangeMgr) GetData(id int32) *server.DB_PropExchange {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_PropExchange.dat", &ProtobufDataLoader{dh: PBDB_PropExchangeMgr})
 }
diff --git a/srvdata/db_rankcycle.go b/srvdata/db_rankcycle.go
index 7792005..f7f114a 100644
--- a/srvdata/db_rankcycle.go
+++ b/srvdata/db_rankcycle.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_RankCycleMgr = &DB_RankCycleMgr{pool: make(map[int32]*server.DB_RankCycle), Datas: &server.DB_RankCycleArray{}}
+var PBDB_RankCycleMgr = &DB_RankCycleMgr{
+    Datas: &server.DB_RankCycleArray{},
+    pool: make(map[int32]*server.DB_RankCycle),
+    
+}
 
 type DB_RankCycleMgr struct {
 	Datas *server.DB_RankCycleArray
 	pool  map[int32]*server.DB_RankCycle
+	
 }
 
 func (this *DB_RankCycleMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_RankCycleMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_RankCycleMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_RankCycleMgr) GetData(id int32) *server.DB_RankCycle {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_RankCycle.dat", &ProtobufDataLoader{dh: PBDB_RankCycleMgr})
 }
diff --git a/srvdata/db_ranklevel.go b/srvdata/db_ranklevel.go
index dd43651..f43183c 100644
--- a/srvdata/db_ranklevel.go
+++ b/srvdata/db_ranklevel.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_RankLevelMgr = &DB_RankLevelMgr{pool: make(map[int32]*server.DB_RankLevel), Datas: &server.DB_RankLevelArray{}}
+var PBDB_RankLevelMgr = &DB_RankLevelMgr{
+    Datas: &server.DB_RankLevelArray{},
+    pool: make(map[int32]*server.DB_RankLevel),
+    
+}
 
 type DB_RankLevelMgr struct {
 	Datas *server.DB_RankLevelArray
 	pool  map[int32]*server.DB_RankLevel
+	
 }
 
 func (this *DB_RankLevelMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_RankLevelMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_RankLevelMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_RankLevelMgr) GetData(id int32) *server.DB_RankLevel {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_RankLevel.dat", &ProtobufDataLoader{dh: PBDB_RankLevelMgr})
 }
diff --git a/srvdata/db_rankreward.go b/srvdata/db_rankreward.go
index 164ddee..205b2cf 100644
--- a/srvdata/db_rankreward.go
+++ b/srvdata/db_rankreward.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_RankRewardMgr = &DB_RankRewardMgr{pool: make(map[int32]*server.DB_RankReward), Datas: &server.DB_RankRewardArray{}}
+var PBDB_RankRewardMgr = &DB_RankRewardMgr{
+    Datas: &server.DB_RankRewardArray{},
+    pool: make(map[int32]*server.DB_RankReward),
+    
+}
 
 type DB_RankRewardMgr struct {
 	Datas *server.DB_RankRewardArray
 	pool  map[int32]*server.DB_RankReward
+	
 }
 
 func (this *DB_RankRewardMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_RankRewardMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_RankRewardMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_RankRewardMgr) GetData(id int32) *server.DB_RankReward {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_RankReward.dat", &ProtobufDataLoader{dh: PBDB_RankRewardMgr})
 }
diff --git a/srvdata/db_sensitive_words.go b/srvdata/db_sensitive_words.go
index 1ce4828..4ffa4a4 100644
--- a/srvdata/db_sensitive_words.go
+++ b/srvdata/db_sensitive_words.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_Sensitive_WordsMgr = &DB_Sensitive_WordsMgr{pool: make(map[int32]*server.DB_Sensitive_Words), Datas: &server.DB_Sensitive_WordsArray{}}
+var PBDB_Sensitive_WordsMgr = &DB_Sensitive_WordsMgr{
+    Datas: &server.DB_Sensitive_WordsArray{},
+    pool: make(map[int32]*server.DB_Sensitive_Words),
+    
+}
 
 type DB_Sensitive_WordsMgr struct {
 	Datas *server.DB_Sensitive_WordsArray
 	pool  map[int32]*server.DB_Sensitive_Words
+	
 }
 
 func (this *DB_Sensitive_WordsMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_Sensitive_WordsMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_Sensitive_WordsMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_Sensitive_WordsMgr) GetData(id int32) *server.DB_Sensitive_Words
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_Sensitive_Words.dat", &ProtobufDataLoader{dh: PBDB_Sensitive_WordsMgr})
 }
diff --git a/srvdata/db_slotrateweight.go b/srvdata/db_slotrateweight.go
index 8ed51f3..a1b4367 100644
--- a/srvdata/db_slotrateweight.go
+++ b/srvdata/db_slotrateweight.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_SlotRateWeightMgr = &DB_SlotRateWeightMgr{pool: make(map[int32]*server.DB_SlotRateWeight), Datas: &server.DB_SlotRateWeightArray{}}
+var PBDB_SlotRateWeightMgr = &DB_SlotRateWeightMgr{
+    Datas: &server.DB_SlotRateWeightArray{},
+    pool: make(map[int32]*server.DB_SlotRateWeight),
+    
+}
 
 type DB_SlotRateWeightMgr struct {
 	Datas *server.DB_SlotRateWeightArray
 	pool  map[int32]*server.DB_SlotRateWeight
+	
 }
 
 func (this *DB_SlotRateWeightMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_SlotRateWeightMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_SlotRateWeightMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_SlotRateWeightMgr) GetData(id int32) *server.DB_SlotRateWeight {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_SlotRateWeight.dat", &ProtobufDataLoader{dh: PBDB_SlotRateWeightMgr})
 }
diff --git a/srvdata/db_systemchance.go b/srvdata/db_systemchance.go
index 02b8e93..2647172 100644
--- a/srvdata/db_systemchance.go
+++ b/srvdata/db_systemchance.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_SystemChanceMgr = &DB_SystemChanceMgr{pool: make(map[int32]*server.DB_SystemChance), Datas: &server.DB_SystemChanceArray{}}
+var PBDB_SystemChanceMgr = &DB_SystemChanceMgr{
+    Datas: &server.DB_SystemChanceArray{},
+    pool: make(map[int32]*server.DB_SystemChance),
+    
+}
 
 type DB_SystemChanceMgr struct {
 	Datas *server.DB_SystemChanceArray
 	pool  map[int32]*server.DB_SystemChance
+	
 }
 
 func (this *DB_SystemChanceMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_SystemChanceMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_SystemChanceMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_SystemChanceMgr) GetData(id int32) *server.DB_SystemChance {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_SystemChance.dat", &ProtobufDataLoader{dh: PBDB_SystemChanceMgr})
 }
diff --git a/srvdata/db_task.go b/srvdata/db_task.go
index 5895733..fa57d81 100644
--- a/srvdata/db_task.go
+++ b/srvdata/db_task.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_TaskMgr = &DB_TaskMgr{pool: make(map[int32]*server.DB_Task), Datas: &server.DB_TaskArray{}}
+var PBDB_TaskMgr = &DB_TaskMgr{
+    Datas: &server.DB_TaskArray{},
+    pool: make(map[int32]*server.DB_Task),
+    
+}
 
 type DB_TaskMgr struct {
 	Datas *server.DB_TaskArray
 	pool  map[int32]*server.DB_Task
+	
 }
 
 func (this *DB_TaskMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_TaskMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_TaskMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_TaskMgr) GetData(id int32) *server.DB_Task {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_Task.dat", &ProtobufDataLoader{dh: PBDB_TaskMgr})
 }
diff --git a/srvdata/db_thirdplatformgamemapping.go b/srvdata/db_thirdplatformgamemapping.go
index 28b6195..76752ae 100644
--- a/srvdata/db_thirdplatformgamemapping.go
+++ b/srvdata/db_thirdplatformgamemapping.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_ThirdPlatformGameMappingMgr = &DB_ThirdPlatformGameMappingMgr{pool: make(map[int32]*server.DB_ThirdPlatformGameMapping), Datas: &server.DB_ThirdPlatformGameMappingArray{}}
+var PBDB_ThirdPlatformGameMappingMgr = &DB_ThirdPlatformGameMappingMgr{
+    Datas: &server.DB_ThirdPlatformGameMappingArray{},
+    pool: make(map[int32]*server.DB_ThirdPlatformGameMapping),
+    
+}
 
 type DB_ThirdPlatformGameMappingMgr struct {
 	Datas *server.DB_ThirdPlatformGameMappingArray
 	pool  map[int32]*server.DB_ThirdPlatformGameMapping
+	
 }
 
 func (this *DB_ThirdPlatformGameMappingMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_ThirdPlatformGameMappingMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_ThirdPlatformGameMappingMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_ThirdPlatformGameMappingMgr) GetData(id int32) *server.DB_ThirdPl
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_ThirdPlatformGameMapping.dat", &ProtobufDataLoader{dh: PBDB_ThirdPlatformGameMappingMgr})
 }
diff --git a/srvdata/db_tips.go b/srvdata/db_tips.go
index c031f0a..012ed7c 100644
--- a/srvdata/db_tips.go
+++ b/srvdata/db_tips.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_TipsMgr = &DB_TipsMgr{pool: make(map[int32]*server.DB_Tips), Datas: &server.DB_TipsArray{}}
+var PBDB_TipsMgr = &DB_TipsMgr{
+    Datas: &server.DB_TipsArray{},
+    pool: make(map[int32]*server.DB_Tips),
+    
+}
 
 type DB_TipsMgr struct {
 	Datas *server.DB_TipsArray
 	pool  map[int32]*server.DB_Tips
+	
 }
 
 func (this *DB_TipsMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_TipsMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_TipsMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_TipsMgr) GetData(id int32) *server.DB_Tips {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_Tips.dat", &ProtobufDataLoader{dh: PBDB_TipsMgr})
 }
diff --git a/srvdata/db_vip.go b/srvdata/db_vip.go
index d58aa42..8ae7c19 100644
--- a/srvdata/db_vip.go
+++ b/srvdata/db_vip.go
@@ -10,11 +10,16 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PBDB_VIPMgr = &DB_VIPMgr{pool: make(map[int32]*server.DB_VIP), Datas: &server.DB_VIPArray{}}
+var PBDB_VIPMgr = &DB_VIPMgr{
+    Datas: &server.DB_VIPArray{},
+    pool: make(map[int32]*server.DB_VIP),
+    
+}
 
 type DB_VIPMgr struct {
 	Datas *server.DB_VIPArray
 	pool  map[int32]*server.DB_VIP
+	
 }
 
 func (this *DB_VIPMgr) unmarshal(data []byte) error {
@@ -34,6 +39,7 @@ func (this *DB_VIPMgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +60,7 @@ func (this *DB_VIPMgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		
 	}
 }
 
@@ -64,6 +71,7 @@ func (this *DB_VIPMgr) GetData(id int32) *server.DB_VIP {
 	return nil
 }
 
+
 func init() {
 	DataMgr.register("DB_VIP.dat", &ProtobufDataLoader{dh: PBDB_VIPMgr})
 }
diff --git a/tools/xlsx2proto/templ/gpb_mgr.templ b/tools/xlsx2proto/templ/gpb_mgr.templ
index 82741aa..4f7a485 100644
--- a/tools/xlsx2proto/templ/gpb_mgr.templ
+++ b/tools/xlsx2proto/templ/gpb_mgr.templ
@@ -10,11 +10,24 @@ import (
     "mongo.games.com/game/protocol/server"
 )
 
-var PB{{.ProtoName}}Mgr = &{{.ProtoName}}Mgr{pool: make(map[int32]*server.{{.ProtoName}}), Datas: &server.{{.ProtoName}}Array{}}
+var PB{{.ProtoName}}Mgr = &{{.ProtoName}}Mgr{
+    Datas: &server.{{.ProtoName}}Array{},
+    pool: make(map[int32]*server.{{.ProtoName}}),
+    {{ range $index, $col := .Cols }}{{ if $col.IsIndex }}
+    {{ if eq $col.ColType 1 }}{{$col.ColName}}: make(map[int32][]*server.{{$.ProtoName}}),
+ 	{{ else if eq $col.ColType 5 }}{{$col.ColName}}: make(map[int64][]*server.{{$.ProtoName}}),
+ 	{{ else if eq $col.ColType 2 }}{{$col.ColName}}: make(map[string][]*server.{{$.ProtoName}}),
+ 	{{end}}{{end}}{{end}}
+}
 
 type {{.ProtoName}}Mgr struct {
 	Datas *server.{{.ProtoName}}Array
 	pool  map[int32]*server.{{.ProtoName}}
+	{{ range $index, $col := .Cols }}{{ if $col.IsIndex }}
+	{{ if eq $col.ColType 1 }}{{$col.ColName}} map[int32][]*server.{{$.ProtoName}}
+	{{ else if eq $col.ColType 5 }}{{$col.ColName}} map[int64][]*server.{{$.ProtoName}}
+	{{ else if eq $col.ColType 2 }}{{$col.ColName}} map[string][]*server.{{$.ProtoName}}
+	{{end}}{{end}}{{end}}
 }
 
 func (this *{{.ProtoName}}Mgr) unmarshal(data []byte) error {
@@ -34,6 +47,9 @@ func (this *{{.ProtoName}}Mgr) reunmarshal(data []byte) error {
 			if existItem == nil {
 				this.pool[item.GetId()] = item
 				this.Datas.Arr = append(this.Datas.Arr, item)
+				{{ range $index, $col := .Cols }}{{ if $col.IsIndex }}
+                this.{{$col.ColName}}[item.Get{{$col.ColName}}()] = append(this.{{$col.ColName}}[item.Get{{$col.ColName}}()], item)
+                {{end}}{{end}}
 			} else {
 				*existItem = *item
 			}
@@ -54,6 +70,9 @@ func (this *{{.ProtoName}}Mgr) arrangeData() {
 
 	for _, data := range dataArr {
 		this.pool[data.GetId()] = data
+		{{ range $index, $col := .Cols }}{{ if $col.IsIndex }}
+        this.{{$col.ColName}}[data.Get{{$col.ColName}}()] = append(this.{{$col.ColName}}[data.Get{{$col.ColName}}()], data)
+        {{end}}{{end}}
 	}
 }
 
@@ -63,6 +82,38 @@ func (this *{{.ProtoName}}Mgr) GetData(id int32) *server.{{.ProtoName}} {
 	}
 	return nil
 }
+{{ range $index, $col := .Cols }}{{ if $col.IsIndex }}
+{{ if eq $col.ColType 1 }}func (this *{{$.ProtoName}}Mgr) Get{{$col.ColName}}(id int32) *server.{{$.ProtoName}} {
+    arr := this.{{$col.ColName}}[id]
+    if len(arr) == 0 {
+        return nil
+    }
+    return arr[0]
+}
+{{ else if eq $col.ColType 5 }}func (this *{{$.ProtoName}}Mgr) Get{{$col.ColName}}(id int64) *server.{{$.ProtoName}} {
+    arr := this.{{$col.ColName}}[id]
+    if len(arr) == 0 {
+        return nil
+    }
+    return arr[0]
+}
+{{ else if eq $col.ColType 2 }}func (this *{{$.ProtoName}}Mgr) Get{{$col.ColName}}(id string) *server.{{$.ProtoName}} {
+    arr := this.{{$col.ColName}}[id]
+    if len(arr) == 0 {
+        return nil
+    }
+    return arr[0]
+}
+{{end}}
+{{ if eq $col.ColType 1 }}func (this *{{$.ProtoName}}Mgr) Get{{$col.ColName}}Arr(id int32) []*server.{{$.ProtoName}} {
+    return this.{{$col.ColName}}[id]
+}
+{{ else if eq $col.ColType 5 }}func (this *{{$.ProtoName}}Mgr) Get{{$col.ColName}}Arr(id int64) []*server.{{$.ProtoName}} {
+    return this.{{$col.ColName}}[id]
+}
+{{ else if eq $col.ColType 2 }}func (this *{{$.ProtoName}}Mgr) Get{{$col.ColName}}Arr(id string) []*server.{{$.ProtoName}} {
+    return this.{{$col.ColName}}[id]
+}{{end}}{{end}}{{end}}
 
 func init() {
 	DataMgr.register("{{.ProtoName}}.dat", &ProtobufDataLoader{dh: PB{{.ProtoName}}Mgr})
diff --git a/tools/xlsx2proto/xlsx2proto.go b/tools/xlsx2proto/xlsx2proto.go
index ca65cba..8c8a950 100644
--- a/tools/xlsx2proto/xlsx2proto.go
+++ b/tools/xlsx2proto/xlsx2proto.go
@@ -15,12 +15,13 @@ var XlsxFiles = make(map[string]string)
 var templates *template.Template
 
 type SheetColumnMetaStruct struct {
-	ColIndex int
-	ColName  string
-	ColType  int
-	CTString string
-	IsArray  bool
-	IsMap    bool
+	ColIndex int    // 列序号
+	ColName  string // 列名称
+	ColType  int    // 数据类型
+	CTString string // proto数据类型
+	IsArray  bool   // 是否数组
+	IsMap    bool   // 是否map
+	IsIndex  bool   // 是否建立索引
 }
 
 type SheetMetaStruct struct {
@@ -31,17 +32,23 @@ type SheetMetaStruct struct {
 }
 
 const (
-	INTTYPE         string = "(int)"
-	INT64TYPE       string = "(int64)"
-	STRTYPE                = "(str)"
-	ARRINTTYPE             = "(arrint)"
-	ARRINT64TYPE           = "(arrint64)"
-	ARRSTRTYPE             = "(arrstr)"
-	INTTYPE_PROTO          = "int32"
-	INT64TYPE_PROTO        = "int64"
-	STRTYPE_PROTO          = "string"
-	MAPTYPE         string = "(map)"
-	MAP_PROTO              = "map"
+	// xlsx标签
+	IntType      = "(int)"
+	Int64Type    = "(int64)"
+	StrType      = "(str)"
+	ArrIntType   = "(arrint)"
+	ArrInt64Type = "(arrint64)"
+	ArrStrType   = "(arrstr)"
+	MapType      = "(map)"
+	// xlsx索引类型,带索引
+	IntTypeIndex   = "(int*)"
+	Int64TypeIndex = "(int64*)"
+	StrTypeIndex   = "(str*)"
+	// proto类型
+	IntTypeProto   = "int32"
+	Int64TypeProto = "int64"
+	StrTypeProto   = "string"
+	MapProto       = "map"
 )
 
 func Init() {
@@ -113,20 +120,25 @@ func main() {
 			for _, row := range sheet.Rows {
 				for i, cell := range row.Cells {
 					s := cell.String()
-					if strings.HasSuffix(s, INTTYPE) {
-						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, INTTYPE), 1, INTTYPE_PROTO, false, false})
-					} else if strings.HasSuffix(s, STRTYPE) {
-						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, STRTYPE), 2, STRTYPE_PROTO, false, false})
-					} else if strings.HasSuffix(s, ARRINTTYPE) {
-						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, ARRINTTYPE), 3, INTTYPE_PROTO, true, false})
-					} else if strings.HasSuffix(s, ARRSTRTYPE) {
-						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, ARRSTRTYPE), 4, STRTYPE_PROTO, true, false})
-					} else if strings.HasSuffix(s, INT64TYPE) {
-						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, INT64TYPE), 5, INT64TYPE_PROTO, false, false})
-					} else if strings.HasSuffix(s, ARRINT64TYPE) {
-						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, ARRINT64TYPE), 6, INT64TYPE_PROTO, true, false})
-					} else if strings.HasSuffix(s, MAPTYPE) {
-						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, MAPTYPE), 7, MAP_PROTO, false, true})
+					switch {
+					case strings.HasSuffix(s, IntType):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, IntType), 1, IntTypeProto, false, false, false})
+					case strings.HasSuffix(s, StrType):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, StrType), 2, StrTypeProto, false, false, false})
+					case strings.HasSuffix(s, ArrIntType):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, ArrIntType), 3, IntTypeProto, true, false, false})
+					case strings.HasSuffix(s, Int64Type):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, Int64Type), 5, Int64TypeProto, false, false, false})
+					case strings.HasSuffix(s, ArrInt64Type):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, ArrInt64Type), 6, Int64TypeProto, true, false, false})
+					case strings.HasSuffix(s, MapType):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, MapType), 7, MapProto, false, true, false})
+					case strings.HasSuffix(s, IntTypeIndex):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, IntTypeIndex), 1, IntTypeProto, false, false, true})
+					case strings.HasSuffix(s, Int64TypeIndex):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, Int64TypeIndex), 5, Int64TypeProto, false, false, true})
+					case strings.HasSuffix(s, StrTypeIndex):
+						sms.Cols = append(sms.Cols, &SheetColumnMetaStruct{i, strings.TrimSuffix(s, StrTypeIndex), 2, StrTypeProto, false, false, true})
 					}
 				}
 				break //only fetch first row
